import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import WebFlow.*;
import WebFlow.event.*;
import org.omg.CORBA.*;
import WebFlow.QS.*;
                               
public class GatewayPortal extends HttpServlet
{
  private ORB orb;
  private WebFlowContext ws = null;
  PrintWriter out;
  String[] SlaveServers;
  boolean slaveOn = false;
  String UserName;
  String Display;
  String challenge;
  private String cmd_line; 

  private String jroot;
  private String jhost,jport;
  private String jurl;
  private String relMasterIor;
  private String masterIOR;
  private String masterIORurl;
  private String iorDirectory; 
  public String  filename;
  public String  UserContext,host;
  public String  relUserConfigDir; 
  public String  userConfigDir; ///npac/home/webflow/WEBFLOW/BeanContext_2.1/QS/
  public String  ior = "hahaha";



  protected void doPost(HttpServletRequest req, HttpServletResponse res)
                       throws ServletException, IOException
  {
    String temp[] = new String[1];
    UserName = req.getParameter("UserContext");
    Display=req.getParameter("DISPLAY");
    host=req.getParameter("HOST"); 
    challenge=req.getParameter("pw");
    System.out.println("User: "+UserName+ "aka "+challenge);

    /* Gateway Web server (gatekeeper) */ 
    jhost=req.getParameter("jhost");              
    jport=req.getParameter("jport");              
    jurl="http://"+jhost+":"+jport;   
    jroot=req.getParameter("jroot");             //WebServer's document root
    relMasterIor=req.getParameter("RelMasterIOR");  //master's IOR
    masterIOR=jroot+relMasterIor;
    masterIORurl=jurl+"/"+masterIOR; 
    iorDirectory=jroot+req.getParameter("RelIorDir");  //modules' IORs
    relUserConfigDir=req.getParameter("UsrConfDir");
    //userConfigDir=jroot+relUserConfigDir;
    userConfigDir=relUserConfigDir;
    filename = jroot+"UserIOR.html";


    if(host.equals(jhost)) {
      cmd_line = 
    "xterm -d "+Display+" -title "+UserName+" -e java WebFlow.Server "+userConfigDir+UserName+".conf";
    }
    else {

    cmd_line = 
    "xterm -d "+Display+" -title telnet -e java -cp .:/npac/home/webflow/WEBFLOW/JIGSAW/classes/jigsaw.zip:/npac/home/globus/akarsu/ORBacus/JOB-3.1.2/lib/OB.jar:/npac/home/webflow/WEBFLOW3/QS/kskim/Swing-1.1.1-beta1/swingall.jar:/npac/home/webflow/WEBFLOW/XML:/npac/home/webflow/WEBFLOW/JIGSAW/Jigsaw/WWW/Gateway/WF:/npac/home/webflow/WEBFLOW/JSDK2.0/lib/jsdk.jar:/npac/home/webflow/WEBFLOW/Telnet/:/npac/home/webflow/WEBFLOW/WWW/MoveFileWebFlow.Server telnetcontainer "+UserName+" "+challenge;
    }    
      /*      
    "xterm -d "+Display+" -e java -cp .:/npac/home/webflow/WEBFLOW/JIGSAW/classes/jigsaw.zip:/npac/home/globus/akarsu/ORBacus/JOB-3.1.2/lib/OB.jar:/npac/home/webflow/WEBFLOW3/QS/kskim/Swing-1.1.1-beta1/swingall.jar:/npac/home/webflow/WEBFLOW/XML:/npac/home/webflow/WEBFLOW/JIGSAW/Jigsaw/WWW/Gateway/WF:/npac/home/webflow/WEBFLOW/JSDK2.0/lib/jsdk.jar:/npac/home/webflow/WEBFLOW/Telnet/:/npac/home/webflow/WEBFLOW/WWW/MoveFileWebFlow.Server WebFlow.Server "+userConfigDir+UserName+".conf";
    */

    temp[0] = "";
    res.setContentType("text/html");
    out = res.getWriter();                                                   

    
    /* connect to the master server */

    String MasterRef = ReadSTRFromFile(masterIOR);
    
    if(pingServer(MasterRef)) {
      System.out.println("master contacted");

      /* check whether the slave already exists */
    slaveOn=false; 
    SlaveServers=ws.getAllWFServers();
    for(int i=0; i<SlaveServers.length; i++) {
      System.out.println(SlaveServers[i]);
      if(SlaveServers[i].indexOf(UserName)>-1) slaveOn=true;
    }
    if(slaveOn) {
      System.out.println("The user context is available...");
    }
    else {
      System.out.println("Start a new user context");
      File oldFile = new File(iorDirectory+UserName+".FileBrowser.txt");
      if(oldFile.exists()) {
	System.out.println("oldFile deleted: "+oldFile.delete());
      }   
      File oldFile1 = new File(iorDirectory+UserName+"xmlServer.txt");
      if(oldFile1.exists()) {
	System.out.println("oldFile deleted: "+oldFile1.delete());
      }   

   System.out.println("create a new slave"); 

     /* generate a new config file */

      System.out.println("UserName = "+UserName);
      System.out.println("file1: "+ userConfigDir+UserName+".conf");
      System.out.println("file2: "+ userConfigDir+"QSslave.conf");
      CopyFile(userConfigDir+UserName+".conf",userConfigDir+"QSslave.conf");
      RandomAccessFile randfile = 
        new RandomAccessFile(userConfigDir+UserName+".conf","rw");
      randfile.writeBytes("ServerName="+UserName+".      "); 


   try {
     Process p = Runtime.getRuntime().exec(cmd_line);        
    } 
     catch (Exception ex) {
     System.err.println("Error in starting WebFlowServer :"+ex);
    }
     /* wait till the server is up */
  
    for (int j=0; j<30; j++) {
       SlaveServers=ws.getAllWFServers();
       for(int i=0; i<SlaveServers.length; i++) {
           System.out.println(SlaveServers[i]);
           if(SlaveServers[i].indexOf(UserName)>-1) slaveOn=true;
           if(slaveOn) break;
           waitForServer(500);
       }     
    }

    }
    
    if(slaveOn) {
      System.out.println("slave is on");
      WebFlowContext uc=null;
      try {
      String serverName=UserName+".";
      System.out.println("connect to server "+serverName);
      org.omg.CORBA.Object ucobj=ws.getWFServer(serverName,"dummy");
      System.out.println("got ucobj");
      if(ucobj==null) System.out.println("ucobj is null");
        uc=WebFlowContextHelper.narrow(ucobj);
      } catch (Exception e7) {
          uc=null; 
          System.out.println("got exception: cannot get the user context");
          System.out.println(e7);
      }
      if(uc!=null) { 
      System.out.println("user context is OK");

	/* add services */
        /* 1. FileBrowser */

        /* is service already available */

      org.omg.CORBA.Object fbobj=null;
      org.omg.CORBA.Object fbobj_old=null;
      boolean FBexists = false;
      String iorFileName = iorDirectory+UserName+".FileBrowser.txt";
      File iorFile = new File(iorFileName);
      if(iorFile.exists()) {
          System.out.println("file "+iorFileName+" exists");
          String FBRef = ReadSTRFromFile(iorFileName);
          System.out.println("returned fromReadSTRFromFile");
          try {
          fbobj_old=orb.string_to_object(FBRef);
          }
          catch (Exception e1) {System.out.println("the ior is useless");} 
          System.out.println("returned from string_to_object");
          if(fbobj_old != null) {
             FileBrowser fb=FileBrowserHelper.narrow(fbobj_old);
             System.out.println("returned narrow");
             if(fb != null) {
                FBexists = true;
        	try {
                  fb.setFileName("test1.txt");
                } catch (Exception e2) {FBexists=false;}
	     }
	  }
          if(!FBexists) {
             boolean x = iorFile.delete();
             System.out.println("ior deleted - "+x);
	  } 
      }
      else {
        System.out.println("iorFile does not exist");
        FBexists = false;
      }   

      if(FBexists) {
          System.out.println("fileBrowser exists");
         fbobj = fbobj_old;
      }
      else {
        System.out.println("fileBrowser does not exist");
        fbobj=uc.addNewModule("FileBrowser");
        if(fbobj==null) System.out.println("Oops, file browser not found!");
        System.out.println("writting IOR to "+iorFileName);
        try {
         FileWriter fwriter = new FileWriter(iorFileName);
         System.out.println("fwriter created"); 
         if(fbobj==null) System.out.println("Oops, file browser not found!");
         if(orb==null) System.out.println("Oops, no orb!");
         String mior = orb.object_to_string(fbobj);
         System.out.println("new IOR = "+mior); 
         fwriter.write(mior);
         fwriter.flush();
         fwriter.close();
         System.out.println(iorDirectory+UserName+".FileBrowser.txt written");
	} catch (Exception eee){System.out.println(eee+" IORwriter exception");}
      }
         /* 2. XML parser */

        /* is service already available */

      org.omg.CORBA.Object xmlpobj=null;
      org.omg.CORBA.Object xmlpobj_old=null;
      boolean XPexists = false;
      String iorFileName2 = iorDirectory+UserName+".xmlServer.txt";
      File iorFile2 = new File(iorFileName2);
      if(iorFile2.exists()) {
          System.out.println("file "+iorFileName2+" exists");
          String XPRef = ReadSTRFromFile(iorFileName2);
          System.out.println("returned fromReadSTRFromFile");
          try {
          xmlpobj_old=orb.string_to_object(XPRef);
          }
          catch (Exception e1) {System.out.println("the ior is useless");} 
          System.out.println("returned from string_to_object");
          if(xmlpobj_old != null) {
             xmlServer XP=xmlServerHelper.narrow(xmlpobj_old);
             System.out.println("returned narrow");
	     //if(XP != null) {
             //   XPexists = true;
             //	try {
             //     XP.setFileName("test1.txt");
             //   } catch (Exception e3) {XPexists=false;}
	     //}
	  }
          if(!XPexists) {
             boolean x = iorFile2.delete();
             System.out.println("ior deleted - "+x);
	  } 
      }
      else {
        System.out.println("iorFile does not exist");
        XPexists = false;
      }   

      if(XPexists) {
          System.out.println("xmlServer exists");
         xmlpobj = xmlpobj_old;
      }
      else {
        System.out.println("xmlServer does not exist");
        xmlpobj=uc.addNewModule("xmlServer");
        if(xmlpobj==null) System.out.println("Oops, xmlParser not found!");
        System.out.println("writting IOR to "+iorFileName2);
        try {
         FileWriter fwriter = new FileWriter(iorFileName2);
         System.out.println("fwriter created"); 
         if(xmlpobj==null) System.out.println("Oops, xmlParser not found!");
         if(orb==null) System.out.println("Oops, no orb!");
         String mior2 = orb.object_to_string(xmlpobj);
         System.out.println("new IOR = "+mior2); 
         fwriter.write(mior2);
         fwriter.flush();
         fwriter.close();
       } catch (Exception eee){System.out.println(eee+" IORwriter exception");}

      }

        /* 3. XMLFileBrowser */

        /* is service already available */

      org.omg.CORBA.Object xfbobj=null;
      org.omg.CORBA.Object xfbobj_old=null;
      boolean XFBexists = false;
      String iorFileName3 = iorDirectory+UserName+".XMLFileBrowser.txt";
      File iorFile3 = new File(iorFileName3);
      if(iorFile3.exists()) {
          System.out.println("file "+iorFileName3+" exists");
          String XFBRef = ReadSTRFromFile(iorFileName3);
          System.out.println("returned fromReadSTRFromFile");
          try {
          xfbobj_old=orb.string_to_object(XFBRef);
          }
          catch (Exception e1) {System.out.println("the ior is useless");} 
          System.out.println("returned from string_to_object");
          if(xfbobj_old != null) {
             FileBrowser xfb=FileBrowserHelper.narrow(xfbobj_old);
             System.out.println("returned narrow");
             if(xfb != null) {
                XFBexists = true;
        	try {
                  xfb.setFileName("test1.txt");
                } catch (Exception e2) {XFBexists=false;}
	     }
	  }
          if(!XFBexists) {
             boolean x = iorFile3.delete();
             System.out.println("ior deleted - "+x);
	  } 
      }
      else {
        System.out.println("iorFile3 does not exist");
        XFBexists = false;
      }   

      if(XFBexists) {
          System.out.println("xmlfileBrowser exists");
         xfbobj = xfbobj_old;
      }
      else {
        System.out.println("fileBrowser does not exist");
        xfbobj=uc.addNewModule("FileBrowser");
        if(xfbobj==null) System.out.println("Oops, file browser not found!");
        System.out.println("writting IOR to "+iorFileName3);
        try {
         FileWriter fwriter = new FileWriter(iorFileName3);
         System.out.println("fwriter created"); 
         if(xfbobj==null) System.out.println("Oops, file browser not found!");
         if(orb==null) System.out.println("Oops, no orb!");
         String mior3 = orb.object_to_string(xfbobj);
         System.out.println("new IOR = "+mior3); 
         fwriter.write(mior3);
         fwriter.flush();
         fwriter.close();
         System.out.println(iorDirectory+UserName+".XMLFileBrowser.txt written");
	} catch (Exception eee){System.out.println(eee+" IORwriter exception");}
      }
     // give the applet back which is there in Demo      
    status("open URL Connection");         
   
    //    java.net.URL url = new java.net.URL("http://osprey4.npac.syr.edu:8001/Gateway/GW.html");
    java.net.URL url = new java.net.URL("http://osprey4.npac.syr.edu:8001/servlets/Frameset?userContext="+UserName);
    InputStream istream1;
    String ref1;
    status("open stream");
   
      istream1 = url.openStream();
          
    		BufferedReader in1 = new BufferedReader(new InputStreamReader(istream1));
        status ("start reading");
          try{
            while(true){
  		ref1 = in1.readLine();
            if(ref1 == null)
		  throw(new EOFException()); 
            out.println(ref1);
            }
      }
   catch(EOFException e){
        error("end of file");
}
   catch(IOException e) {
      error("Can't open URL: " + url);
     // throw new Exception("Can't open URL: " + url);
      }

      }
      else {
       out.println("Sorry, connot connect to your context");
      }
    } 
    else {
      System.out.println("slave is not responding!");
      out.println("Sorry, cannot access your context");
    }
    }
    else {
      System.out.println("master is not responding!");
      out.println("Sorry, the WebFlow system is down!");
    }
 //out.close(); 
}

  org.omg.CORBA.Object resolveWFServer(ORB orb)
                     throws Exception
  {
    WebFlowContext root_ctx;
    String ref;

    java.net.URL url = new java.net.URL(masterIORurl);
    InputStream istream;
    try {
      istream = url.openStream();
  		BufferedReader in = new BufferedReader(new InputStreamReader(istream));
  		ref = in.readLine();
  		istream.close();
      }
    catch(IOException e) {
      error("Can't open URL: " + url);
      throw new Exception("Can't open URL: " + url);
      }

    org.omg.CORBA.Object obj = orb.string_to_object(ref);
    if(obj == null)
  		throw new RuntimeException();
    root_ctx = WebFlowContextHelper.narrow(obj);
    if(root_ctx == null)
      throw new RuntimeException();
// get uc_1 from the portal page and make a context with that.

    return root_ctx.addNewContext(UserName);
  }
  
  private void save(String data) throws IOException
  {
 //   StringOutputStream output =
  //    new StringOutputStream(new FileOutputStream(filename));
    	FileOutputStream foutput = 
                   new FileOutputStream(filename);
    
    foutput.write(data.getBytes());
    
    foutput.close();
  }
 
  void error(String msg)
  {
    //out.println(msg);
  }

  void status(String msg)
  {
    //out.println(msg);
  }
                              
  public String getServletInfo()
  {
  return "By Praveen";
  }

  public boolean pingServer (String MasterRef)
  {   
    System.out.println("Pinging the server");
    if (MasterRef.equals("")) { 
     System.out.println("Cannot read reference from the file\n" +  masterIOR);
     return false;
    } 
    else
    { 
      ws=Str2Obj(MasterRef);  
      if (ws == null) {
         System.out.println("Cannot Connect to Object");
         return false;
      }
      else
      {
	boolean non_exist = true;
	try{
	    non_exist = ws._non_existent();
	}
        catch(org.omg.CORBA.COMM_FAILURE ex){}
	catch(org.omg.CORBA.OBJECT_NOT_EXIST ex){}

        return !non_exist;

    }  //else
  }  //pingServer
  }
    public synchronized void waitForServer(long delay){
        System.err.println("waiting...");
        try {
           wait(delay);
        } catch(InterruptedException e){
                 System.out.println("Intrrupted exc :"+e);
        }
    }

  public String ReadSTRFromFile(String masterIOR) 
       //          throws FileNotFoundException, IOException
  {
      //open a file
      FileInputStream theFile;
      BufferedReader fileReader;
      String sObjRef;

      try {
           theFile=new FileInputStream(masterIOR);
           fileReader=new BufferedReader(new InputStreamReader(theFile));
      }
      catch(FileNotFoundException e){
           return "";
      }

      //read a reference string
      try {
        sObjRef=fileReader.readLine();
        System.err.println("Got the reference: "+sObjRef);
      }
      catch (IOException e) {
        return "";
      }
      
      try {
        theFile.close();
        fileReader.close();
      }
      catch (IOException e) {}

      //return the reference string
      return sObjRef;
  }

  protected  WebFlowContext Str2Obj(String sObjRef)
  {
    String[] args = new String[1];
    args[0] = new String("");

    orb = ORB.init(args, new java.util.Properties());
    if(orb == null)
    {
      System.err.println("ORB connecting error");
      return null ; //"ORB connecting error";
    }
    else
    {
      System.err.println("ORB is created successfully");
      org.omg.CORBA.Object obj = orb.string_to_object(sObjRef); ;
      return  WebFlowContextHelper.narrow(obj);
    }
  }

  public void CopyFile(String outfilename,String infilename)
  {

   try{
      File inputFile = new File(infilename);
      File outputFile = new File(outfilename);
      FileReader in1 = new FileReader(inputFile);
      FileWriter out1 = new FileWriter(outputFile);
      int c;
      while ((c = in1.read()) != -1){
             out1.write(c);
      }
      in1.close();
      out1.close();
   }
   catch (IOException e){
       System.err.println("copying the file: "+e);
   }
  }      
}



